POJ3126,Prime Path,想漏了一点,坑了好久

7 篇文章 0 订阅

Prime Path

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

分析:

题意就是从已知的一个素数(四位)改变到另一个给出的素数(四位),但每次只能改变一个位数,还要保证改变中的每一个中间数都要是素数...(坑爹的部长= =)

STL提供了这么方便的queue没理由不用不是。。。这里的判断素数多写了几行貌似能省一点时间= =。关键是后一个数的生成,考虑个十百千位,每一位有10种情况,

也就是40入口的bfs...但在个位可以只考虑奇数...忘了中间两位可以用0填,导致测试的一组数据第一趟循环找不到下一个结点进队,头结点又出队,直接导致下一趟对空队列进行front(),操作停止运行...调试到夜里两点多还找不出原因啊操,最后还是写了一个生成已知数的下一个素数的程序找出只比那个数大一个数的素数测试发现百位还是十位是0......


code:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<queue>
using namespace std;
int a,b;
typedef struct Node
{
    int x,step;
}Node;
bool IsPrime(int digit)
{
	if(digit==2 || digit==3)
		return true;
	else if(digit<=1 || digit%2==0)
		return false;
	else if(digit>3)
	{
		for(int i=3;i*i<=digit;i+=2)
			if(digit%i==0)
				return false;
		return true;
	}
}
bool vis[10000];
void bfs()
{
    queue<Node> q;
    while(!q.empty())
        q.pop();
    Node first={a,0};
    q.push(first);
    vis[a]=true;
    while(!q.empty())
    {

        Node tmp=q.front();
        if(tmp.x==b)
        {
            printf("%d\n",tmp.step);
            return;
        }
        for(int i=1;i<10;i+=2)//个位
        {
            Node tmp1;
            tmp1.x=tmp.x/10*10+i;
            if(!vis[tmp1.x]&&IsPrime(tmp1.x))
            {
                vis[tmp1.x]=true;
                tmp1.step=tmp.step+1;
                q.push(tmp1);
            }
        }
        for(int i=0;i<10;i++)//十位
        {
            Node tmp2;
            tmp2.x=tmp.x%10+tmp.x/100*100+i*10;
            if(tmp2.x!=tmp.x&&!vis[tmp2.x]&&IsPrime(tmp2.x))
            {
                vis[tmp2.x]=true;
                tmp2.step=tmp.step+1;
                q.push(tmp2);
            }
        }
        for(int i=0;i<10;i++)//百位
        {
            Node tmp3;
            tmp3.x=tmp.x%100+tmp.x/1000*1000+i*100;
            if(tmp3.x!=tmp.x&&!vis[tmp3.x]&&IsPrime(tmp3.x))
            {
                vis[tmp3.x]=true;
                tmp3.step=tmp.step+1;
                q.push(tmp3);
            }
        }
        for(int i=1;i<10;i++)//千位
        {
            Node tmp4;
            tmp4.x=i*1000+tmp.x%1000;
            if(tmp4.x!=tmp.x&&!vis[tmp4.x]&&IsPrime(tmp4.x))
            {
                vis[tmp4.x]=true;
                tmp4.step=tmp.step+1;
                q.push(tmp4);
            }
        }
        q.pop();
    }
    printf("Impossible\n");
    return;
}
int main()
{
    int n;
    scanf("%d",&n);
    while(n--)
    {
        memset(vis,false,sizeof(vis));
        scanf("%d %d",&a,&b);
        bfs();
    }
    return 0;
}


CCF大数据与计算智能大赛-面向电信行业存量用户的智能套餐个性化匹配模型联通赛-复赛第二名-【多分类,embedding】.zip项目工程资源经过严格测试可直接运行成功且功能正常的情况才上传,可轻松复刻,拿到资料包后可轻松复现出一样的项目,本人系统开发经验充足(全领域),有任何使用问题欢迎随时与我联系,我会及时为您解惑,提供帮助。 【资源内容】:包含完整源码+工程文件+说明(如有)等。答辩评审平均分达到96分,放心下载使用!可轻松复现,设计报告也可借鉴此项目,该资源内项目代码都经过测试运行成功,功能ok的情况下才上传的。 【提供帮助】:有任何使用问题欢迎随时与我联系,我会及时解答解惑,提供帮助 【附带帮助】:若还需要相关开发工具、学习资料等,我会提供帮助,提供资料,鼓励学习进步 【项目价值】:可用在相关项目设计中,皆可应用在项目、毕业设计、课程设计、期末/期中/大作业、工程实训、大创等学科竞赛比赛、初期项目立项、学习/练手等方面,可借鉴此优质项目实现复刻,设计报告也可借鉴此项目,也可基于此项目来扩展开发出更多功能 下载后请首先打开README文件(如有),项目工程可直接复现复刻,如果基础还行,也可在此程序基础上进行修改,以实现其它功能。供开源学习/技术交流/学习参考,勿用于商业用途。质量优质,放心下载使用。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值